'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.postcssOptions = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.happypackPlugin = happypackPlugin;
exports.vueStyleLoaders = vueStyleLoaders;
exports.cssLoaders = cssLoaders;

var _happypack = require('happypack');

var _happypack2 = _interopRequireDefault(_happypack);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _autoprefixer = require('autoprefixer');

var _autoprefixer2 = _interopRequireDefault(_autoprefixer);

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function happypackPlugin(id, loaders) {
  var compilerThreadPool = _happypack2.default.ThreadPool({ size: _os2.default.cpus().length });
  return new _happypack2.default({
    id: id,
    verbose: false,
    threadPool: compilerThreadPool,
    loaders: loaders
  });
}

var postcssOptions = exports.postcssOptions = function postcssOptions(context) {
  return _extends({
    plugins: [(0, _autoprefixer2.default)({ browsers: ['last 2 versions'] })],
    sourceMap: 'inline'
  }, context.postcss || {});
};

function vueStyleLoaders(context, preprocessor) {
  var loaders = cssLoaders(_extends({}, context, { isDev: true }), preprocessor);
  loaders = loaders.filter(function (v, i) {
    return i > 0 && i !== 2;
  });
  if (!context.isDev) {
    return _extractTextWebpackPlugin2.default.extract({
      use: loaders,
      fallback: 'vue-style-loader'
    });
  }
  return ['vue-style-loader'].concat(loaders);
}

function cssLoaders(context) {
  var preprocessor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  var loaders = [{ loader: require.resolve('style-loader') }, { loader: require.resolve('css-loader'), options: { minimize: !context.isDev } }, {
    loader: require.resolve('postcss-loader'),
    options: postcssOptions(context)
  }, { loader: require.resolve('resolve-url-loader'), options: { debug: false } }];
  if (preprocessor) {
    if (typeof preprocessor === 'string') {
      loaders = loaders.concat({
        loader: require.resolve(preprocessor + '-loader'),
        options: { sourceMap: true }
      });
    } else if ((typeof preprocessor === 'undefined' ? 'undefined' : _typeof(preprocessor)) === 'object') {
      loaders = loaders.concat(_extends({}, preprocessor, {
        loader: require.resolve(preprocessor.loader)
      }));
    } else {
      throw new Error('invalid preprocessor');
    }
  }
  if (!context.isDev) {
    return _extractTextWebpackPlugin2.default.extract({
      use: loaders.slice(1),
      fallback: loaders[0]
    });
  }
  return loaders;
}